#include <stdio.h>
#include <math.h>

/* Dit programma lost de volgende vergelijking op:
   x^2-wortel^2=0. De wortel^2 is een gevraagde input door het programma.
*/

int main (void)
{
	char s;
    float xl, xr ;       /* grenzen zoekinterval        */
    float xm ;           /* midden zoekinterval         */
    float fl, fm ;       /* de vgl.  in xl en xm        */
    float eps = 0.0001 ; /* minimum intervallengte      */
    float wortelsq ;     /* wortel^2 zoals in de vgl.   */
    float wortel ;       /* de berekende wortel         */
    float onzekerheid ;  /* de onzekerheid in de wortel */

/*        invoer van getal                              */
    printf(" geef de wortelsq  \n") ;
    scanf(" %f", &wortelsq) ;
   
    
    printf(" we lossen op: x^2 - %f =0  \n", wortelsq) ;

/*        begingrenzen zoekinterval                     */
    xl = 0. ;
    xr = wortelsq  ; /* dit is een veilige keuze voor als x>1 */
    if (xr<1) xr=1;
    

/*        HIER BEGINT DE while-loop                     */
    while ( xr - xl > eps )
    {
      xm = (xl + xr ) / 2. ;    /* midden van interval */
      fl=xl*xl-wortelsq;        /* de vgl. in xl */
      fm=xm*xm-wortelsq;        /* de vgl. in xm */
      
      if ( fl*fm<=0 )  /* indien teken wisselt zijn we voorbij de oplossing */
	{
	  xr = xm ;             /* rechtergrens omlaag */
	}
      else
	{
	  xl = xm ;             /* linkergrens omhoog  */
	}
      printf(" xl xr %f %f\n", xl, xr) ;     /* tussenresultaat */
    }
    
    /*        eindresultaat                                 */
    wortel      = ( xr + xl ) / 2. ;
    onzekerheid = ( xr - xl ) / 2. ; 
    
    printf(" wortel = %f  onzekerheid = %f \n", wortel, onzekerheid);
    	   	// truukje om het output venster even open te houden
    printf("type enter to continue");
	s=getchar();  // 1 getchar is taken from the enter in the buffer of scanf
    s=getchar();  // this one pauses the screen 
    return 0 ;
}


